<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Bouncing Rect</title>
    <style>
        #canvas {
            width: 400px;
            height: 400px;
            position: relative;
            background-color: yellow;
        }
        #rect {
            width: 50px;
            height: 50px;
            position: absolute;
            background-color: red;
        }
    </style>
</head>
<body>
    <h1>Bouncing Rect</h1>
    <p>
        <button id="run" onclick="run()">Start</button>
        <input type="number" id="interval" value="5" min="1" max="100"/>
    </p>
    <div id="canvas">
        <div id="rect"></div>
    </div>

    <script>
        function inside(lb, v, ub) {
            return lb <= v && v <= ub;
        }
        function uniform(lb, ub) {
            return Math.round(lb + Math.random() * (ub - lb));
        }

        var runButton     = document.getElementById('run');
        var rect          = document.getElementById('rect');
        var intervalField = document.getElementById('interval');
        var intervalId    = null;

        function run() {
            if (intervalId) {
                clearInterval(intervalId);
                intervalId          = null;
                runButton.innerHTML = 'Start';
                return;
            }

            var x               = uniform(1, 350);
            var y               = uniform(1, 350);
            var dx              = 1;
            var dy              = 1;
            var interval        = intervalField.value;
            runButton.innerHTML = 'Stop';
            intervalId          = setInterval(mover, interval);

            function mover() {
                rect.style.top  = x + 'px';
                rect.style.left = y + 'px';
                x += dx;
                y += dy;
                if (!inside(0, x, 350)) dx = -dx;
                if (!inside(0, y, 350)) dy = -dy;
            }
        }
    </script>
</body>
</html>
